package gyak_5;

import java.util.ArrayList;

public class Main_5
{
    public Job[] Johnson(Job[] jobokBe, int gepA, int maxIdo)
    {
        int min;
        int i;
        int N = jobokBe.length;
        int gepB = gepA + 1;
        int minJob = -1;
        GepEnum gep = null;
        int eleje = 0;
        int vege = 0;
        Job Sopt[] = new Job[N];
        ArrayList<Job> jobok = new ArrayList<Job>();

        //job tömb elemeinek átrakása egy ideiglenes listába
        for(i=0; i<N; i++)
        {
			jobok.add(jobokBe[i]);
        }

        for(i=0; i<N; i++)
		{
			//megnézi hogy hol van a minimum
			min = 2*maxIdo;

			for(int j=0; j<N-i; j++)
			{
				Job tmpJob = jobok.get(j);
				if(tmpJob.getGepIdo(gepA) <=min)
				{
					min = tmpJob.getGepIdo(gepA);
					minJob = j;
					gep = GepEnum.A;
				}
				if(tmpJob.getGepIdo(gepB)<=min)
				{
					min = tmpJob.getGepIdo(gepB);
					minJob = j;
					gep = GepEnum.B;
				}
			}

			if(gep == GepEnum.A)
			{
				Job tmpJob = jobok.get(minJob);
				Sopt[eleje] = tmpJob;
				eleje ++;
				jobok.remove(minJob);
			}
			else
			{
				Job tmpJob = jobok.get(minJob);
				Sopt[N-1-vege] = tmpJob;
				vege ++;
				jobok.remove(minJob);
			}
		}

		return Sopt;
    }

	public int Gannt(Job[] jobok, int gepekSzama)
	{
		int Cmax;
		int N = jobok.length;

		//nulladik job
		jobok[0].setGepSt(0, 0); //nulladik job nulladik gépe 0 időpontban kezd
		jobok[0].setGepEt(0, jobok[0].getGepIdo(0)); //és a 0. gépen eltöltött idő után fejezi be

		for(int i=1; i<gepekSzama; i++)
		{
			jobok[0].setGepSt(i, jobok[0].getGepEt(i-1)); //az i-edik gépen akkor kezdi a munkát amikor az i-1 en befejezte
			jobok[0].setGepEt(i, jobok[0].getGepSt(i) + jobok[0].getGepIdo(i)); //és (kezdés + gépidő)-kor fejezi be
		}

		//többi job
		for(int i=1; i<N; i++) //jobok
		{
			jobok[i].setGepSt(0, jobok[i-1].getGepEt(0)); //az iedik job akkor kezdi el a munkát a 0. gépen amikor az előtte lévő job befejezte
			jobok[i].setGepEt(0, jobok[i].getGepSt(0) + jobok[i].getGepIdo(0));

			for(int j=1; j<gepekSzama; j++) //gépek
			{
				if(jobok[i].getGepEt(j-1) > jobok[i-1].getGepEt(j)) //ha az iedik job az előző gépen később fejezi be a munkát mint az előző job ezen a gépen...
				{
					jobok[i].setGepSt(j, jobok[i].getGepEt(j-1)); //akkor az iedik job ezen a gépen akkor kezd amikor az előző gépen befejezte a munkát
					jobok[i].setGepEt(j, jobok[i].getGepSt(j) + jobok[i].getGepIdo(j));
				}
				else
				{
					jobok[i].setGepSt(j, jobok[i-1].getGepEt(j)); //egyébként akkor kezd amikor az előző job befejezte ezen a gépen
					jobok[i].setGepEt(j, jobok[i].getGepSt(j) + jobok[i].getGepIdo(j));
				}
			}
		}
		Cmax = jobok[N-1].getGepEt(gepekSzama-1);
		return Cmax;
	}

    public static void main(String[] args)
    {
		Main_5 xx = new Main_5();
        int N = 50; //jobok száma
        int M = 10; //gépek száma
        int i; //segédváltozó
        int maxIdo = 20; //maximális gépidő

        Job[] jobok = new Job[N];
		Job[] Sopt = new Job[N];
		int Cmax;


		//jobok létrehozása
        for(i=0; i<N; i++)
        {
            jobok[i] = new Job(i, M, maxIdo);
        }
		
		//Johnson algoritmusok végrehajtása
		Sopt = xx.Johnson(jobok, 0, maxIdo);
		Cmax = xx.Gannt(Sopt, M);

		for(i=1; i<M-1; i++)
		{
			Job[] tmpSopt = xx.Johnson(jobok, i, maxIdo);
			int tmpCmax = xx.Gannt(tmpSopt, M);

			if(tmpCmax < Cmax)
			{
				Cmax = tmpCmax;
				Sopt = tmpSopt;
			}
		}

		System.out.println("\nCmax:" + Cmax);
	}
}
