package gyak_6;

/**
 *
 * @author Simon Csaba
 */
public class Gep
{
	int id;
	int j;
	Intervallum[] intervallumok = null;
	int hossz;//intervallum hossza
	int tavolsag;//intervallumok közötti távolság
	int tmpSt;
	int tmpEt;

	public Gep(int id, int I)
	{
		this.id = id;

		intervallumok = new Intervallum[I];
		
		hossz = 10+(int)(Math.random()*20);
		intervallumok[0] = new Intervallum(0, 0, hossz);
		for(j=1; j<I; j++)
		{
			hossz = 10+(int)(Math.random()*20);
			tavolsag = 10+(int)(Math.random()*5);
			tmpSt = intervallumok[j-1].getEt()+tavolsag;
			tmpEt = tmpSt + hossz;

			intervallumok[j] = new Intervallum(j, tmpSt, tmpEt);
		}
	}

	@Override
	public String toString()
	{
		String eredmeny = id + "\n";
		for(j=0; j<intervallumok.length; j++)
		{
			eredmeny = eredmeny + intervallumok[j].toString() + "\n";
		}

		return eredmeny;
	}

	public Intervallum[] getIntervallumok()
	{
		return intervallumok;
	}

	public class Intervallum
	{
		private int st;
		private int et;
		private int id;

		public Intervallum(int id, int st, int et)
		{
			this.id = id;
			this.st = st;
			this.et = et;
		}

		public int getEt()
		{
			return et;
		}

		public int getSt()
		{
			return st;
		}

		public int getId()
		{
			return id;
		}

		public void setSt(int st)
		{
			this.st = st;
		}

		@Override
		public String toString()
		{
			return "st:" + st + ", et:" + et;
		}
	}
}
