package gyak_6;

/**
 *
 * @author Simon Csaba
 */
public class Job
{
	VirtualisGep[] gepIdok = null;
	int i = 0;
	int id = 0;

	public Job(int id, int gepekSzama)
	{
		this.id = id;

		gepIdok = new VirtualisGep[gepekSzama];
		
		for(i=0; i<gepekSzama; i++)
		{
			int tmp = (int)(Math.random()*20);
			gepIdok[i] = new VirtualisGep(10+tmp);
		}
	}

	public int getGepIdo(int gepSorszam)
	{
		return gepIdok[gepSorszam].getIdo();
	}

	public int getGepSt(int gepSorszama)
	{
		return gepIdok[gepSorszama].getSt();
	}

	public int getGepEt(int gepSorszam)
	{
		return gepIdok[gepSorszam].getEt();
	}

	public void setGepSt(int gepSorszam, int ujSt)
	{
		gepIdok[gepSorszam].setSt(ujSt);
	}

	public void setGepEt(int gepSorszam, int ujEt)
	{
		gepIdok[gepSorszam].setEt(ujEt);
	}

	private class VirtualisGep
	{
		int ido;
		int st;
		int et;

		public VirtualisGep(int ido)
		{
			this.ido = ido;
		}

		public int getEt()
		{
			return et;
		}

		public int getIdo()
		{
			return ido;
		}

		public int getSt()
		{
			return st;
		}

		public void setEt(int et)
		{
			this.et = et;
		}

		public void setSt(int st)
		{
			this.st = st;
		}		
	}
}
