package gyak_6;

import gyak_6.Gep.Intervallum;
import java.util.ArrayList;

/**
 *
 * @author Simon Csaba
 */
public class Main_6
{
	private static Gep[] gepek = null;
	
	public Job[] Johnson(Job[] jobokBe, int gepA)
    {
        int min;
        int i;
        int N = jobokBe.length;
        int gepB = gepA + 1;
        int minJob = -1;
        GepEnum gep = null;
        int eleje = 0;
        int vege = 0;
        Job Sopt[] = new Job[N];
        ArrayList<Job> jobok = new ArrayList<Job>();

        //job tömb elemeinek átrakása egy ideiglenes listába
        for(i=0; i<N; i++)
        {
			jobok.add(jobokBe[i]);
        }

		for(i=0; i<N; i++)
		{
			//megnézi hogy hol van a minimum
			min = Integer.MAX_VALUE;

			for(int j=0; j<N-i; j++)
			{
				Job tmpJob = jobok.get(j);
				if(tmpJob.getGepIdo(gepA) <=min)
				{
					min = tmpJob.getGepIdo(gepA);
					minJob = j;
					gep = GepEnum.A;
				}
				if(tmpJob.getGepIdo(gepB)<=min)
				{
					min = tmpJob.getGepIdo(gepB);
					minJob = j;
					gep = GepEnum.B;
				}
			}

			if(gep == GepEnum.A)
			{
				Job tmpJob = jobok.get(minJob);
				Sopt[eleje] = tmpJob;
				eleje ++;
				jobok.remove(minJob);
			}
			else
			{
				Job tmpJob = jobok.get(minJob);
				Sopt[N-1-vege] = tmpJob;
				vege ++;
				jobok.remove(minJob);
			}
		}

		return Sopt;
    }

	//load_stet_to_cal
	public void berak(Job job, int gep, int utolso)//gép sorszáma, aktuális gép honnan terhelhető
	{
		int i = 0;
		int st = job.getGepSt(gep);
		int et = job.getGepEt(gep);

		int hossz = et-st;
		st = max(st, utolso);
		et = st + hossz;

		while(i < gepek[gep].getIntervallumok().length)
		{
			Intervallum iv = gepek[gep].getIntervallumok()[i];
			//ha hamarabb kezdődik mint az adott intervallum vége
			if(st < iv.getEt())
			{
				//a kezdő értéket beállítom vagy az eredeti startra, vagy az intervallum kezdetére
				st = max(st, iv.getSt());
				et = st + hossz;

				//ha hamarabb befejeződik mint az intervallum
				if(et <= iv.getEt())
				{
					//akkor ki lehet lépni a ciklusból
					break;
				}
				//egyébként
				else
				{
					//egy intervallumot lépek előre
					i++;
					//ha nem értem el az intervallumok végére
					if(i < gepek[gep].getIntervallumok().length)
					{
						//beállítom st az intervallum elejére, et-t hozzá,
						iv = gepek[gep].getIntervallumok()[i];
						st = iv.getSt();
						et = st + hossz;
					}
					//ha elértem az intervallumok végére
					else
					{
						//berakom a jobot az egész végére, és kilépek
						st = gepek[gep].getIntervallumok()[i-1].getSt();
						et = st + hossz;
						break;
					}
					//lépek egyet a ciklusban; ha a következő körben stimmel a dolog nyert ügyem van, ha nem akkor folytatom a dolgot
					continue;
				}
			}
			else
			{
				i++;
			}
		}
		//a végén beállítom a job aktuális gépen történő kezdő és befejező időpontját
		job.setGepSt(gep, st);
		job.setGepEt(gep, et);
	}

	public int max(int a, int b)
	{
		if(a>b)
			return a;
		else
			return b;
	}

	public int Gannt(Job[] jobok, int gepekSzama)
	{
		int Cmax;
		int N = jobok.length;

		//nulladik job
		jobok[0].setGepSt(0, 0); //nulladik job nulladik gépe 0 időpontban kezd
		jobok[0].setGepEt(0, jobok[0].getGepIdo(0)); //és a 0. gépen eltöltött idő után fejezi be
		//de nem folyamatosan üzemel a gép, ezért az előző elméleti értéket valós értékre állítjuk
		berak(jobok[0], 0, 0);

		for(int i=1; i<gepekSzama; i++)
		{
			jobok[0].setGepSt(i, jobok[0].getGepEt(i-1)); //az i-edik gépen akkor kezdi a munkát amikor az i-1 en befejezte
			jobok[0].setGepEt(i, jobok[0].getGepSt(i) + jobok[0].getGepIdo(i)); //és (kezdés + gépidő)-kor fejezi be
			//de nem folyamatosan üzemel a gép, ezért az előző elméleti értéket valós értékre állítjuk
			berak(jobok[0], i, 0);
		}

		//többi job
		for(int i=1; i<N; i++) //jobok
		{
			jobok[i].setGepSt(0, jobok[i-1].getGepEt(0)); //az iedik job akkor kezdi el a munkát a 0. gépen amikor az előtte lévő job befejezte
			jobok[i].setGepEt(0, jobok[i].getGepSt(0) + jobok[i].getGepIdo(0));
			//de nem folyamatosan üzemel a gép, ezért az előző elméleti értéket valós értékre állítjuk
			berak(jobok[i], 0, 0);

			for(int j=1; j<gepekSzama; j++) //gépek
			{
				if(jobok[i].getGepEt(j-1) > jobok[i-1].getGepEt(j)) //ha az iedik job az előző gépen később fejezi be a munkát mint az előző job ezen a gépen...
				{
					jobok[i].setGepSt(j, jobok[i].getGepEt(j-1)); //akkor az iedik job ezen a gépen akkor kezd amikor az előző gépen befejezte a munkát
					jobok[i].setGepEt(j, jobok[i].getGepSt(j) + jobok[i].getGepIdo(j));
					//de nem folyamatosan üzemel a gép, ezért az előző elméleti értéket valós értékre állítjuk
					berak(jobok[i], j, 0);
				}
				else
				{
					jobok[i].setGepSt(j, jobok[i-1].getGepEt(j)); //egyébként akkor kezd amikor az előző job befejezte ezen a gépen
					jobok[i].setGepEt(j, jobok[i].getGepSt(j) + jobok[i].getGepIdo(j));
					//de nem folyamatosan üzemel a gép, ezért az előző elméleti értéket valós értékre állítjuk
					berak(jobok[i], j, 0);
				}
			}
		}
		Cmax = jobok[N-1].getGepEt(gepekSzama-1);
		return Cmax;
	}

	public static void main(String[] args)
    {
		Main_6 xx = new Main_6();
        int N = 5; //jobok száma
        int M = 3; //gépek száma
        int i, j; //segédváltozó
        int maxIdo = 20; //maximális gépidő

        Job[] jobok = new Job[N];
		gepek = new Gep[M];
		Job[] Sopt = new Job[N];
		int Cmax;


		//jobok létrehozása
        for(i=0; i<N; i++)
        {
            jobok[i] = new Job(i, M);
        }

		//gépek létrehozása
		for(j=0; j<M; j++)
		{
			gepek[j] = new Gep(j, 20);
		}

		//Johnson algoritmusok végrehajtása
		Sopt = xx.Johnson(jobok, 0);
		Cmax = xx.Gannt(Sopt, M);

		for(i=1; i<M-1; i++)
		{
			Job[] tmpSopt = xx.Johnson(jobok, i);
			int tmpCmax = xx.Gannt(tmpSopt, M);

			if(tmpCmax < Cmax)
			{
				Cmax = tmpCmax;
				Sopt = tmpSopt;
			}
		}

		System.out.println("Cmax:" + Cmax);
	}


}
